## rock-master-20.01-tools-service-discovery 0.20190404

=== CMakeLists.txt ===
# CMakeLists.txt has to be located in the project folder and cmake has to be
# executed from 'project/build' with 'cmake ../'.

cmake_minimum_required(VERSION 2.6)
find_package(Rock)
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH}" "${CMAKE_SOURCE_DIR}/cmake")
set(PROJECT_DESCRIPTION "Service discovery based on AVAHI")

include(FindPkgConfig)
pkg_check_modules(SIGC++ REQUIRED "sigc++-2.0")
## Using the quotation marks to get the ';' as field separator for string lists 
list(APPEND MY_CFLAGS ${SIGC++_INCLUDE_DIRS})
string(REGEX REPLACE ";" " -I" THIS_PKG_CFLAGS "${MY_CFLAGS}")
message(${THIS_PKG_CFLAGS})
set(THIS_PKG_CFLAGS "-I${THIS_PKG_CFLAGS}")
message(${THIS_PKG_CFLAGS})

find_package(Boost REQUIRED COMPONENTS regex system)
include_directories(${Boost_INCLUDE_DIRS})
link_directories(${Boost_LIBRARY_DIRS})

rock_init(service_discovery 1.0)
rock_standard_layout()

=== src/CMakeLists.txt ===
set(SOURCES
    impl/avahi/Client.cpp
    impl/avahi/LocalService.cpp
    impl/avahi/RemoteService.cpp
    impl/avahi/Service.cpp
    impl/avahi/ServiceBrowser.cpp
    impl/avahi/ServiceDiscovery.cpp
    impl/avahi/ServiceDescription.cpp
    impl/avahi/ServiceEvent.cpp
    impl/avahi/ServiceConfiguration.cpp
    impl/avahi/ServicePattern.cpp
)

set( HEADERS
    impl/avahi/ServiceDiscovery.hpp
    impl/avahi/Service.hpp
    impl/avahi/ServiceDescription.hpp
    impl/avahi/ServicePattern.hpp
    impl/avahi/LocalService.hpp
    impl/avahi/RemoteService.hpp
    utils/List.hpp
    impl/avahi/Client.hpp
    impl/avahi/ServiceBrowser.hpp
    impl/avahi/ServiceConfiguration.hpp
    impl/avahi/ServiceEvent.hpp
    ServiceDiscovery.hpp
    service_discovery/backward/service_discovery/service_discovery.h
)

find_package(Threads)
rock_library(${PROJECT_NAME} 
                    SOURCES ${SOURCES}
                    HEADERS ${HEADERS}
                    DEPS_PKGCONFIG sigc++-2.0
                        base-logging
                        avahi-client
                        avahi-core
                        dbus-1
                    DEPS_PLAIN Threads
)
target_link_libraries(${PROJECT_NAME} ${Boost_REGEX_LIBRARY} ${Boost_SYSTEM_LIBRARY} ${CMAKE_THREAD_LIBS_INIT})

set(UTIL_BROWSE ${PROJECT_NAME}-browse)
rock_executable(${UTIL_BROWSE} utils/Browse.cpp
                     DEPS ${PROJECT_NAME})
set(UTIL_PUBLISH ${PROJECT_NAME}-publish)

rock_executable(${UTIL_PUBLISH} utils/Publish.cpp
                     DEPS ${PROJECT_NAME})

add_subdirectory(examples)

=== test/CMakeLists.txt ===
rock_testsuite(servicediscovery-test
  suite.cpp
  discovery_test.cpp
  configuration_test.cpp
  search_pattern_test.cpp
  DEPS service_discovery)
    
add_executable(sdtest EXCLUDE_FROM_ALL
  test.cpp ${SOURCES}
)
target_link_libraries(sdtest service_discovery)

=== bindings/ruby/CMakeLists.txt ===
include(RockRuby)
include_directories(${CMAKE_BINARY_DIR}/include)
rock_find_pkgconfig(BASE_TYPES REQUIRED base-logging)
rock_find_pkgconfig(SIGC_TYPES REQUIRED sigc++-2.0)
rock_ruby_rice_extension(servicediscovery_ruby ext/ServiceDiscovery.cpp)
target_link_libraries(servicediscovery_ruby service_discovery)
set(FILES lib/servicediscovery.rb
    lib/servicediscovery/core.rb
    )

rock_ruby_library(servicediscovery ${FILES})

=== src/examples/CMakeLists.txt ===
set(EXAMPLES
    Browse
    BrowsePublishUpdate
    Publish
    ServiceDiscovery
    Update
)

# build all defined examples
foreach(currentExample ${EXAMPLES})
  add_executable(${currentExample} ${currentExample}.cpp)
  target_link_libraries(${currentExample} ${PROJECT_NAME} ${EXTERNAL_LIBS}
  -lpthread)
endforeach(currentExample)

=== debian/changelog ===
rock-master-20.01-tools-service-discovery (0.20190404-1~jessie) unstable; urgency=low

  * Package automatically built using 'apaka'
  * repository: github:/rock-core/tools-service_discovery.git
  * branch: refs/heads/master
  * commit: c80de675abe7ed97041f98f08db176a3a4aa8b3e
  * tag: 

 -- Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>  Mon, 10 Feb 2020 14:29:14 +0100

=== debian/control ===
Source: rock-master-20.01-tools-service-discovery
Section: science
Priority: optional
Maintainer: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Uploaders: Rock Packaging Daemon (based on apaka) <rock-dev@dfki.de>
Build-Depends: cdbs, debhelper (>= 8.0.0), pkg-config, dh-autoreconf, autoconf, automake, avahi-daemon, build-essential, cmake, libavahi-client-dev, libavahi-client3, libavahi-core-dev, libboost-dev, libboost-filesystem-dev, libboost-graph-dev, libboost-iostreams-dev, libboost-program-options-dev, libboost-regex-dev, libboost-system-dev, libboost-thread-dev, libsigc++-2.0-0c2a, libsigc++-2.0-dev, rake, rock-master-20.01-base-cmake, rock-master-20.01-base-logging, rock-master-20.01-ruby-rice, rubygems-integration
Standards-Version: 3.9.2
Homepage: http://www.rock-robotics.org

Package: rock-master-20.01-tools-service-discovery
Architecture: any
Depends: ${shlibs:Depends}, rock-master-20.01-base-cmake, rock-master-20.01-base-logging, cmake, avahi-daemon, libavahi-client3, libavahi-client-dev, libavahi-core-dev, libsigc++-2.0-0c2a, libsigc++-2.0-dev, libboost-dev, libboost-graph-dev, libboost-program-options-dev, libboost-regex-dev, libboost-thread-dev, libboost-filesystem-dev, libboost-iostreams-dev, libboost-system-dev, automake, autoconf, build-essential, rake, rubygems-integration, rock-master-20.01-ruby-rice
Description: Service discovery based on AVAHI
 In order to find distributed components and offered services, a distributed services discovery is required. AVAHI provides a basic library, which will be used in this package to develop a high level API.

=== debian/rules ===
#!/usr/bin/make -f

# BEGIN ENVIRONMENT SETUP
# https://www.debian.org/doc/debian-policy/ch-source.html
# nocheck: This tag says to not run any build-time test suite provided by the package.
export DEB_BUILD_OPTIONS=nocheck

# Setup of $(arch), $(rockruby_libdir) and $(rockruby_archdir)
arch=$(shell gcc -print-multiarch)
ruby_ver=$(shell ruby --version)
ruby_arch_dir=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['archdir']")
ruby_libdir=$(shell ruby -r rbconfig -e "print RbConfig::CONFIG['rubylibdir']")
rockruby_archdir=$(subst /usr,,$(ruby_arch_dir))
rockruby_libdir=$(subst /usr,,$(ruby_libdir))
# Setup of paths: PATH,PKG_CONFIG_PATH,RUBYLIB,...
master2001_install_dir = /opt/rock/master-20.01
env_setup =  PATH=$(master2001_install_dir)/bin:$(PATH)
env_setup += HOME=/home/ 
env_setup += RUBYLIB=$(master2001_install_dir)/$(rockruby_libdir):$(master2001_install_dir)/$(rockruby_archdir):$(master2001_install_dir)/lib/ruby/vendor_ruby/standard:$(master2001_install_dir)/lib/ruby/vendor_ruby/core:$(master2001_install_dir)/lib/ruby/vendor_ruby:$(RUBYLIB)
env_setup += PKG_CONFIG_PATH=$(master2001_install_dir)/lib/pkgconfig:$(master2001_install_dir)/lib/$(arch)/pkgconfig:/usr/share/pkgconfig:/usr/lib/$(arch)/pkgconfig:$(PKG_CONFIG_PATH)
env_setup += Rock_DIR=$(master2001_install_dir)/share/rock/cmake:$(Rock_DIR)
env_setup += LD_LIBRARY_PATH=$(master2001_install_dir)/lib:$(master2001_install_dir)/lib/$(arch):$(LD_LIBRARY_PATH)
env_setup += CMAKE_PREFIX_PATH=$(master2001_install_dir):$(CMAKE_PREFIX_PATH)
env_setup += OROGEN_PLUGIN_PATH=$(master2001_install_dir)/share/orogen/plugins:$(OROGEN_PLUGIN_PATH)
export TYPELIB_CXX_LOADER=gccxml
export DEB_CPPFLAGS_APPEND=-std=c++11
export npm_config_cache=/tmp/npm
rock_library_dirs=$(master2001_install_dir)/lib:$(master2001_install_dir)/lib/$(arch):
rock_install_dir=/opt/rock/master-20.01
# Check if a python command is available and identify the version
# and identify the setup.py file
python_cmd=$(shell command -v python 2> /dev/null)
ifneq ("$(python_cmd)","")
python_version=$(shell python -c 'import sys; print "{0}.{1}".format(sys.version_info[0],sys.version_info[1])')
# Get dirname a setup.py match
python_setup_dir=$(shell find $(DEB_SRCDIR) -name setup.py | tail -n 1 | xargs dirname)
endif

DEB_VERBOSE_ALL=1
include /usr/share/cdbs/1/rules/debhelper.mk
extra_lib_dir=$(shell pwd)/debian/rock-master-20.01-tools-service-discovery$(rock_install_dir)/lib
# This argument list is forwarded to dh_shlibdeps which takes the -l option and a colon separated list of libraries
# (not that this is different from the linker arguments)
DEB_DH_SHLIBDEPS_ARGS_ALL=-l$(extra_lib_dir):$(extra_lib_dir)/$(arch):$(rock_library_dirs)

rock_doc_install_dir=$(rock_install_dir)/share/doc/rock-master-20.01-tools-service-discovery

pre-build::
	echo "Detected:"
	echo "   ruby version: $(ruby_ver)"
	echo "   ruby libdir: $(rockruby_libdir)"
	echo "   ruby archdir: $(rockruby_archdir)"

	#echo "Current directory:"
	#find .

# END ENVIRONMENT SETUP
######################################
# BEGIN OROGEN -- This block needs to be executed before CMAKE


# END OROGEN
######################################
# BEGIN CMAKE
#
# Defining the cmake command and setting the required enviroment variables
# PKG_CONFIG_PATH Resolve Rock package via pkg-config
# Rock_DIR Set to make sure find_package(Rock) does work
# ROCK_CMAKE_MACROS Used in some patches to set the CMAKE_MODULE_PATH, allowing to find Rock.cmake
CMAKE = $(env_setup) cmake
DEB_CMAKE_INSTALL_PREFIX = $(rock_install_dir)

# Debian packaging discourages the use of rpath, but
# cdbs actively sets CMAKE_SKIP_RPATH=ON, so reinforcing OFF here
DEB_CMAKE_EXTRA_FLAGS = -DCMAKE_SKIP_RPATH=OFF
# Telling FindGEM.cmake to search for os packages using pkg-config and not for gems
DEB_CMAKE_EXTRA_FLAGS += -DGEM_OS_PKG=TRUE
# Leaving RUBY_EXECUTABLE unset since it maps to a path of the user executing the upload script
DEB_CMAKE_EXTRA_FLAGS +=  -DCMAKE_EXPORT_COMPILE_COMMANDS="ON" -DROCK_USE_CXX11="ON"
# Disable ROCK Testing -- since running test on the OBS would require proper setting of path, etc. (see. data_processing/type_to_vector)
DEB_CMAKE_EXTRA_FLAGS += -DROCK_TEST_ENABLED=OFF -UROCK_TEST_LOG_DIR
include /usr/share/cdbs/1/class/cmake.mk

# END CMAKE
##########################################
# BEGIN AUTOTOOLS
#


# http://cdbs-doc.duckcorp.org/en/cdbs-doc.xhtml see post-configure actions
# replace all entries of -I with -I and -isystem in order to 
#   (a) guarantee that pkgconfig can still knowns the include directory (-I)
#   (b) the include directory is actually accounted for as system include directory (-isystem)
# Account for the fact, that configure is called multiple times e.g. revert changes first, then reapply
configure/rock-master-20.01-tools-service-discovery::
	echo "Adapt -I to -isystem in pkgconfig files:"
	find . -name '[a-zA-Z]*.pc' -exec sh -c "echo Adapting {}; sed -i 's#\(\"\?\)-isystem[^ ]\+\1##g; s#\(\"\?\)-I\([^ ]\+\)\1#\1-I\2\1 \1-isystem\2\1#g; s#[ ]\+# #g' {}; cat {};" \;
	find . -name '[a-zA-Z]*.pc' -exec sh -c "echo Cleanup {}; sed -i 's#-isystem/usr/include # #g' {}; sed -i 's#-I/usr/include # #g' {}; cat {}" \;

###########################################
# DOCS


# Build docs
# This checks for Doxyfile and runs doxygen with that.
# Otherwise, it tries the "doc" target.
# Since docs are not critical, ignore failures('-' on recipe line start).
# The make call is supposed to be invoked even if -t or -n is selected,
# with the appropriate flags('+' on recipe line start)

common-build-arch common-build-indep:: debian/stamp-rock-doc
debian/stamp-rock-doc:
	-+$(DEB_MAKE_INVOKE) doc
	touch $@

common-install-arch common-install-indep:: common-install-rock-doc install-extensions
common-install-rock-doc::
	mkdir -p $(DEB_DESTDIR)$(rock_doc_install_dir)
	$(if $(wildcard $(DEB_SRCDIR)/doc/html),-cp -r "$(DEB_SRCDIR)/doc/html" "$(DEB_DESTDIR)$(rock_doc_install_dir)",$(if $(wildcard $(DEB_SRCDIR)/doc),-cp -r "$(DEB_SRCDIR)/doc" "$(DEB_DESTDIR)$(rock_doc_install_dir)"))
	$(if $(wildcard $(DEB_BUILDDIR)/doc/html),-cp -r "$(DEB_BUILDDIR)/doc/html" "$(DEB_DESTDIR)$(rock_doc_install_dir)",$(if $(wildcard $(DEB_BUILDDIR)/doc),-cp -r "$(DEB_BUILDDIR)/doc" "$(DEB_DESTDIR)$(rock_doc_install_dir)"))

install-extensions:: install-python
install-python::
ifneq ("$(python_setup_dir)","")
	echo "Installing python extension in $(python_setup_dir)"
	mkdir -p $(DEB_DESTDIR)$(rock_install_dir)/lib/python$(python_version)/site-packages
	cd $(python_setup_dir); $(python_cmd) setup.py build; PYTHONPATH=$(DEB_DESTDIR)$(rock_install_dir)/lib/python$(python_version)/site-packages/ $(python_cmd) setup.py install --prefix=$(DEB_DESTDIR)$(rock_install_dir); cd -
endif

clean::
	rm -f debian/stamp-rock-doc
	rm -rf $(DEB_SRCDIR)/doc/html


# END DOCS
###########################################
